#lang racket

;; 

;; ---

;; TODO print spreadsheet ... may want to reorganize Q's for LTL + LTLf output
;;  describe, write, both have 2 parts

(define ltlf-tracereject*
  '((tr "Q15" "Q16" "X(G(r))" "{r}*" "too short")
    (tr "Q17" "Q18" "r U (!r & F(b))" "{r} {r} {}" "mismatch")
    (tr "Q19" "Q20" "G(r) & Xw(Xw(!r))" "{r} {r} {r}" "too long")
    (tr "Q21" "Q22" "F(G(!r))" "{g} {r}" "mismatch")
    (tr "Q23" "Q24" "r & G(r => X(X(r)))" "{r} {} {} {r} {} {} {r}" "inf only")))

(define ltlf-tracematch*
  '((tm "Q32" "Q33" "G(F(r))" "{r} {} {} {r}" "Yes")
    (tm "Q34" "Q35" "r U (!r)" "{r} {r} {r}" "No")
    (tm "Q36" "Q37" "F(!X(r))" "{r} {r}" "Yes")
    (tm "Q38" "Q39" "F(X(!r))" "{r} {r}" "No")
    (tm "Q40" "Q41" "F(G(r))" "{} {} {} {r}" "Yes")
    (tm "Q42" "Q43" "F(r & F(b))" "{b} {r} {r} {b}" "Yes")))

(define ltlf-describe*
  '( ;; ltl
    (d "Q50" "" "F(r => F(!r))" "if red, must have !red in future")
    (d "Q54" "" "(r U b) & G(r)" "always r, eventually b")
    (d "Q58" "" "r & !X(b)" "r now, !b next")
    (d "Q62" "" "G(r => X(!r & X(r)))" "whenever r, off/on evermore")
    ;; ltlf
    (d "Q51" "Q52" "F(r => F(!r))" "same")
    (d "Q55" "Q56" "(r U b) & G(r)" "r for all states, b for some")
    (d "Q59" "Q60" "r & !X(b)" "r now, if next !b")
    (d "Q63" "Q64" "G(r => X(!r & X(r)))" "never r")))

(define ltlf-identity*
  '((i "Q70" "Q71" "F(a) == true U a" "True")
    (i "Q72" "Q73" "!X(a) == X(!a)" "False")
    (i "Q74" "Q75" "X(G(a)) == G(X(a))" "False")
    (i "Q76" "Q77" "X(a U b) == X(a) U X(b)" "True")
    (i "Q78" "Q79" "G(a) == a & X(G(a))" "False")
    (i "Q80" "Q81" "F(a) == a || X(F(a))" "True")
    (i "Q82" "Q83" "G(F(a)) == F(G(a))" "True")))

(define ltlf-write*
  '( ;; ltl
    (w "Q90"   "" "whenever r, cannot be next with g" "G(r => !X(g))")
    (w "Q94"   "" "There are at least two states in which the Blue light is on" "F(b & X(F(b)))")
    (w "Q98"   "" "Green is on in the final state." "inexpressible")
    (w "Q102"  "" "Blue on in 1, off in 2, alts evermore" "b & G(b => X(!b & X(b)))")
    (w "Q106"  "" "Red is on exactly once." "!r U (r & G(!X(r)))")
    ;; ltlf
    (w "Q91" "Q92" "whenever r, cannot be next with g" "same")
    (w "Q95" "Q96" "There are at least two states in which the Blue light is on" "same")
    (w "Q99" "Q100" "Green is on in the final state." "F(g & Xw(false))")
    (w "Q103" "Q104" "Blue on in 1, off in 2, alts evermore" "b & G(b => Xw(!b & Xw(b)))")
    (w "Q107" "Q108" "Red is on exactly once." "same")))


(define ltl-traceq*
  '(("Q15" "Q16" "G(X(r))" "{gb} {rgb}*" "Yes")
    ("Q17" "Q18" "r" "{gb} {rgb}*" "No")
    ("Q19" "Q20" "F(r)" "{r} {}*" "Yes")
    ("Q21" "Q22" "X(X(X(r)))" "{r} {} {} {r} {}*" "Yes")
    ("Q23" "Q24" "G(r => X(X(X(r))))" "{} {rgb} {rgb} {} {rgb}*" "Yes")
    ("Q25" "Q26" "r U g" "{rb} {rb} {rb} {rgb} {b}*" "Yes")
    ("Q27" "Q28" "F(r) & F(g)" "{} {g} {} {} {r}*" "Yes")
    ("Q29" "Q30" "X(X(F(r)))" "{rgb}*" "Yes")
    ("Q31" "Q32" "r U b" "{r}*" "No")
    ("Q33" "Q34" "F(G(r))" "{} {rgb} {} {rgb} {}*" "No")
    ("Q35" "Q36" "F(r => g)" "{}*" "Yes")))

(define ltl-leq*
  '(("Q44" "Q45" "G(F(r))" "r infinitely often")
    ("Q46" "Q47" "r => X(X(X(r)))" "if red now, then red in 3 steps")
    ("Q48" "Q49" "X(X(F(X(r))))" "r in 3 or more steps")
    ("Q50" "Q51" "F(r) => G(b)" "if any r, then all b")
    ("Q52" "Q53" "(r U b) & G(r)" "always r and eventually b")
    ("Q54" "Q55" "G(r => X(!r) & X(X(r)))" "whenever r, off next on next-next")))

(define ltl-elq*
  '(("Q61" "Q62" "Whenever Red, it is off in the next state and on again in the state after that." "G(r ==> X(!r) & XX(r))")
    ("Q63" "Q64" "Red in exactly one state, not necessarily the first" "(!r) U (r & X(G(!r)))")
    ("Q65" "Q66" "Red cannot stay on 3 states in a row" "!F(r & Xr & XXr)")
    ("Q67" "Q68" "Whenever Red, then Blue then or later" "G(r ==> F(b))")
    ("Q69" "Q70" "r for zero or more, then !r forevermore" "(r U !r) & (G(!r ==> G(!r)))")))


(define traceq* ltl-traceq*)
(define leq*    ltl-leq*)
(define elq*    ltl-elq*)

(define (parse tsv)
  (define line* (file->lines tsv))
  #;(printf "nlines = ~s~n" (length line*))
  (define q* (tab-split (first line*)))
  (define prompt* (tab-split (second line*)))
  (define NCOL (length q*))
  (define row**
    ;; ignore first three lines
    (for/list ([str (in-list (cdddr line*))])
      (define vv (tab-split str))
      (define nc (length vv))
      (if (= nc NCOL)
        vv
        (raise-arguments-error 'badlen "bad row" "expected" NCOL "got" nc "row" vv))
      ))
  #;(printf "looks okay?~n ~s~n ~s~n ~a~n"
          q*
          #;prompt*
          (first row**)
          (third row**))
  (list q* prompt* row**))

(define (*index-of xx x)
  (define rr (index-of xx x))
  (or rr (raise-arguments-error 'index-of "not found" "key" x "list" xx)))

(define (ltlf-tagged dd qq)
  (define-values [q* prompt* row**] (apply values dd))
  (define id-idx (*index-of q* "ResponseId"))
  ;; TODO lots of copy/paste below!
  (define vv
    (case (car (car qq))
      ((tr)
    (for/list ((rq (in-list qq)))
      (define ans-idx (*index-of q* (second rq)))
      (define exp-idx (*index-of q* (third rq)))
      (define formula (fourth rq))
      (define trace (fifth rq))
      (define expected (sixth rq))
      (for/list ((rr (in-list row**)))
        ;; Answer	Explanation	ID	Formula	Trace	Expected
        (list (list-ref rr ans-idx)
              (list-ref rr exp-idx)
              (list-ref rr id-idx)
              formula
              trace
              expected))))

      ((tm)
    (for/list ((rq (in-list qq)))
      (define ans-idx (*index-of q* (second rq)))
      (define exp-idx (*index-of q* (third rq)))
      (define formula (fourth rq))
      (define trace (fifth rq))
      (define expected (sixth rq))
      (for/list ((rr (in-list row**)))
        ;; Answer	Explanation	ID	Formula	Trace	Expected
        (list (list-ref rr ans-idx)
              (list-ref rr exp-idx)
              (list-ref rr id-idx)
              formula
              trace
              expected))))

      ((d)
    (for/list ((rq (in-list qq)))
      (define ans-idx (*index-of q* (second rq)))
      (define exp-idx
        (let ((ss (third rq)))
          (and (non-empty-string? ss)
               (*index-of q* ss))))
      (define formula (fourth rq))
      (define expected (fifth rq))
      (for/list ((rr (in-list row**)))
  ;; Answer	Explanation	ID	Formula	Expected
        (list (list-ref rr ans-idx)
              (if exp-idx (list-ref rr exp-idx) "")
              (list-ref rr id-idx)
              formula
              expected))))

      ((i)
    (for/list ((rq (in-list qq)))
      (define ans-idx (*index-of q* (second rq)))
      (define exp-idx (*index-of q* (third rq)))
      (define formula (fourth rq))
      (define expected (fifth rq))
      (for/list ((rr (in-list row**)))
        ;; Answer	Explanation	ID	Formula	Expected
        (list (list-ref rr ans-idx)
              (list-ref rr exp-idx)
              (list-ref rr id-idx)
              formula
              expected))))

      ((w)
    (for/list ((rq (in-list qq)))
      (define ans-idx (*index-of q* (second rq)))
      (define exp-idx
        (let ((ss (third rq)))
          (and (non-empty-string? ss)
               (*index-of q* ss))))
      (define formula (fourth rq))
      (define expected (fifth rq))
      (for/list ((rr (in-list row**)))
  ;; Answer	Explanation	ID	Formula	Expected
        (list (list-ref rr ans-idx)
              (if exp-idx (list-ref rr exp-idx) "")
              (list-ref rr id-idx)
              formula
              expected))))

      (else (raise-argument-error 'print-tagged "question-type?" dd))))
  vv)


(define (trace-sat dd)
  (define-values [q* prompt* row**] (apply values dd))
  (define id-idx (*index-of q* "ResponseId"))
  (define vv
    (for/list ((rq (in-list traceq*)))
      (define ans-idx (*index-of q* (first rq)))
      (define exp-idx (*index-of q* (second rq)))
      (define formula (third rq))
      (define trace (fourth rq))
      (define expected (fifth rq))
      (for/list ((rr (in-list row**)))
        ;; Answer	Explanation	ID	Formula	Trace	Expected
        (list (list-ref rr ans-idx)
              (list-ref rr exp-idx)
              (list-ref rr id-idx)
              formula
              trace
              expected))))
  vv)

(define (ltl->eng dd)
  (get-5x dd leq*))

(define (eng->ltl dd)
  (get-5x dd elq*))

(define (get-5x dd qq*)
  ;; Answer	Explanation	ID	Formula	Expected
  (define-values [q* prompt* row**] (apply values dd))
  (define id-idx (*index-of q* "ResponseId"))
  (define vv
    (for/list ((rq (in-list qq*)))
      (define ans-idx (*index-of q* (first rq)))
      (define exp-idx (*index-of q* (second rq)))
      (define formula (third rq))
      (define expected (fourth rq))
      (for/list ((rr (in-list row**)))
        (list (list-ref rr ans-idx)
              (list-ref rr exp-idx)
              (list-ref rr id-idx)
              formula
              expected))))
  vv)

(define (tab-split str)
  (string-split str "\t"))

(define (tab-join str*)
  (string-join str* "\t"))

(define (print-sheet xx)
  (for* ((qq (in-list xx))
         (rr (in-list qq)))
    (displayln (tab-join rr))))

(define (print-ltl tsv)
    (let ((dd (parse tsv)))
      (printf "Trace Sat~n")
      (print-sheet (trace-sat dd))
      (printf "~n~n")
      (printf "L -> E~n")
      (print-sheet (ltl->eng dd))
      (printf "~n~n")
      (printf "E -> L~n")
      (print-sheet (eng->ltl dd))
      (printf "~n~n")
      (void)))

(define (print-ltlf tsv)
    (let ((dd (parse tsv)))
      (for ((qq (in-list   (list ltlf-tracereject* ltlf-tracematch* ltlf-describe* ltlf-identity* ltlf-write*)))
            (name (in-list '("Reject Traces" "Match Traces" "Describe Formulas" "Check Identities" "Write Formulas"))))
        (displayln name)
        (print-sheet (ltlf-tagged dd qq))
        (newline)
        (newline))))

;; ---

(module+
  main
  (require racket/cmdline)
  (command-line
    #:args (tsv)
    #;(print-ltl tsv)
    (print-ltlf tsv)
    (void)))
